
import javax.swing.JPanel;
import java.awt.image.*;
import java.util.*;
import java.awt.*;

//------------------------------------------------------------------------//
//						Trieda plochy na vykreslovanie					  //
//------------------------------------------------------------------------//

class FloyCanvas extends JPanel implements Runnable{										//Floys Place - trieda panelu, na ktory sa bude vsetko vykreslovat

    BufferedImage image=null;
    Thread animation;
    ArrayList objects;						//pole floyov
    ArrayList barriers;						//pole prekazok
    static int floys_count=10;						//pocet floyov
    static int floys_vot_count=10;						//pocet floyov
    int canvas_width=455;					//rozmery platna
    int canvas_height=365;
    FApplet aplet;
    int alien_count=0;						//pocet_votrelcov
    int index_of_death_floy=-1;				//index vyskytu floya s energiou 0
    
	private static int neighbor_dist;					//vzdialenost susedstva
	private static int crash_dist;						//kolizna vzdialenost
	private static int max_pocet_votrelcov;				//maximalny pocet votrelcov
	static int model_prostredia = 2;					//model prostredia sa nastavi na ohranicny
	static boolean is_cursor_visible= false;
	public boolean setni;
	boolean kresliHranice;
	
	int maxEnergy;
	int healingRate;
	int zmenaEnergie; 
	int hniezdoDst; 
	float poklesEnergie;
	
	public void setMaxEnergy(int c) { maxEnergy=c;}
	public void setHealingRate(int c) { healingRate=c;}
	public void setZmenaEnergie(int c) { zmenaEnergie=c;}
	public void setHniezdoDst(int c) { hniezdoDst=c;}
	public void setPoklesEnergie(float c) { poklesEnergie=c;}
	public int getHniezdoDst() { return hniezdoDst;}
	public int getMaxEnergy() { return maxEnergy;}
	public int getHealingRate() { return healingRate;}
	public int getZmenaEnergie() { return zmenaEnergie;}
	public float getPoklesEnergie() { return zmenaEnergie;}
	
	
	void setKresliHranice(boolean x){ kresliHranice=x; }
	Barrier cursor;
	
    public FloyCanvas(FApplet aplet) 														//konstruktor vytvara pole floyov
      {
      	Floy.Floys = this;
      	Floy.maxspeed = 3f;
	  	Floy.bouncespeed = 0.8f;
	  	Floy.acc = 0.1f;
	  	Floy.v0 = 4f;
	  	neighbor_dist=150;
	  	crash_dist = 20;
	  	max_pocet_votrelcov = 50;

		maxEnergy = 200;
		healingRate = 1;
		zmenaEnergie = 2; 	  	
		hniezdoDst= 50; 	  	
	  	
      	this.aplet = aplet;
        objects = new ArrayList();
        barriers = new ArrayList();
        cursor = new Barrier(10,20,30);
        setni=true;
        kresliHranice=false;
        poklesEnergie=0.0f;
        
        Floy newObject;
        
        for(int i = 0; i < floys_count;i++)
          {
            newObject = new Floy((int)(5+Math.random()*(canvas_width-10)) ,(int)(5+Math.random()*(canvas_height-10)) , maxEnergy/2, 10, Color.black, 0);	//vytvorenie noveho jedinca
            objects.add(newObject);
            newObject.start();
          }
        for(int i = 0; i < floys_vot_count;i++)
        {
          newObject = new Floy((int)(5+Math.random()*(canvas_width-10)) ,(int)(5+Math.random()*(canvas_height-10)) , maxEnergy/2, 10, Color.black, 1);	//vytvorenie noveho jedinca
          objects.add(newObject);
          newObject.start();
        }
        start();
      }

    public void start() 																	//spustenie vlakna animacie	
      {
	    animation = new Thread(this);
     	animation.setPriority(Thread.MIN_PRIORITY);
    	animation.start();
      }

    public synchronized void stop() 
      {
	    animation = null;
	    notify();
      }
    
    synchronized void kontrolaEnergie(){
        for(int i = 0; i < objects.size(); i++)	{										//vykreslenie floyov
        	if(((Floy)objects.get(i)).energy<=0) 
        	{
        		OdstranMrtvehoFloya(i);
        	} else
        		if(((Floy)objects.get(i)).energy==((Floy)objects.get(i)).getMaxEnergy() && aplet.cbSex.getState()==true) 
        		{
        			PridajNovehoFloya(i);
        		}
	        }
	    }
    
    public void run() 																		//vykreslovanie animacie
      {
	    Graphics2D area = null;
	    Dimension size = getSize();
	    double t=0;
        while (true) 
          {
        	if((t+=1)>999) t=0;	// 1 den :)
        	
            try 
              {
                animation.sleep(15);
              } 
            catch (InterruptedException e) 
              {
                return;
              }
            if (image == null) 
              {
	   	       image = (BufferedImage) createImage(canvas_width, canvas_height);			//vytvorenie platna o zadanom rozmere
	          }
			if (image == null) 
			  {
		  		continue;
		  	  }
	        if (area == null) 
	          {
		        area = image.createGraphics();
		      }
		    
		    area.clearRect(0, 0, canvas_width, canvas_height);
 

    	    aplet.labTime.setText(new Double(t).toString());
    	    aplet.sldTime.setValue((int)t);

    	    
    	    String info = new String();
    	    info = "Speria dve skupiny floyov";
    	    //info+=infohome;
    	    if(aplet.cbCas.getState()==true) info+=", v noci sa vracaj do hniezda";
    	    if(aplet.cbZachrana.getState()==true) info+=", zranen utekaj do hniezda";
    	    if(aplet.cbHniezdo.getState()==true) info+=", v blzkosti hniezda sa zskavaj energiu";
    	    info+=" (tmav jedinci s silnej, svetlej slab).";
    	    
    	    switch(aplet.chHranice.getSelectedIndex()){
    	    	case 0: { info+=" Ako votrelec sa sprva vzdialenej z domu."; } break;
    	    	case 1: { info+=" Ako votrelec sa sprva vzdialenej z domu."; } break;
    	    	case 3: { info+=" Votrelec sa na hranici 40-60% vyberie nhodne, energia sa zmen poda vsledku sboja."; } break;
    	    	case 2: { info+=" Votrelec sa na hranici 40-60% vyberie nhodne, energia klesne obom (nava)."; } break;
    	    	case 4: { info+=" Modr s predtori."; } break;
    	    	case 5: { info+=" erven s predtori."; } break;
    	    	case 6: { info+=" Hranica je 50% vzdialenosti hniezd, za ou s votrelci ."; } break;
    	    }
        	int vx=0,vy=0,dx=0,dy=0;
        	String infohome="";
    	    
        	switch(aplet.chScenario.getSelectedIndex()){
    		case 0: { vx = 50; vy=50; dx=400; dy=300; infohome=" s hniezdami v protiahlch rohoch";} break;
    		case 1: { vx = 215; vy=50; dx=215; dy=310; infohome=" s hniezdami na stranch";} break;
    		case 2: { vx = 160; vy=180; dx=270; dy=180; infohome=" s hniezdami blzko seba";} break;
    		case 3: { vx = 215; vy=180; dx=215; dy=180; infohome=" so spolonm hniezdom";} break;
    		default : { vx = 50; vy=50; dx=400; dy=300; }
    	}

    	    if(aplet.cbSex.getState()==true) info+=" A po dosiahnut dostatonej energie sa rozmnouj.";
    	    aplet.taInfo.setText(info);
    	    
            for(int i = 0; i < objects.size(); i++)	{										//vykreslenie floyov
                ((Floy)objects.get(i)).setTime(t); 
                //if(setni==true){
                ((Floy)objects.get(i)).setCas(aplet.cbCas.getState()); 
                ((Floy)objects.get(i)).setHniezdo(aplet.cbHniezdo.getState()); 
                ((Floy)objects.get(i)).setZachrana(aplet.cbZachrana.getState()); 
                ((Floy)objects.get(i)).setHranice(aplet.chHranice.getSelectedIndex()); 
                ((Floy)objects.get(i)).setHome(dx,dy,vx,vy); 
                ((Floy)objects.get(i)).setDrawHranice(kresliHranice); 
                ((Floy)objects.get(i)).setMnozenie(aplet.cbSex.getState()); 
                ((Floy)objects.get(i)).setHealingRate(healingRate); 
                ((Floy)objects.get(i)).setMaxEnergy(maxEnergy); 
                ((Floy)objects.get(i)).setZmenaEnergie(zmenaEnergie); 
                ((Floy)objects.get(i)).setPoklesEnergie(poklesEnergie); 
                ((Floy)objects.get(i)).setHniezdoDst(hniezdoDst); 
                ((Floy)objects.get(i)).setPoklesEnergie(poklesEnergie);   ((Floy)objects.get(i)).selfPaint(area);
            }

    	    kontrolaEnergie();
            for(int i = 0; i < barriers.size(); i++)										//vykreslenie prekazok
              {
               ((Barrier)barriers.get(i)).selfPaint(area); 
              } 
            if (is_cursor_visible)  
              cursor.selfPaint(area);
		    repaint();
	        Thread.yield();
          }
       }

    public void paint(Graphics g) 															//metoda na vykreslenie celeho platna
      {
	    synchronized (this) 
	      {
	        Graphics2D g2d = (Graphics2D) g;
	        if (image != null) 
	          {
	           g2d.drawImage(image, null, 0, 0);
	          }
          }
      }
      
   public void PauseFloys(boolean isPaused)													//metoda na zastavenie vsetkych floyov
     {
       for(int i = 0; i < objects.size(); i++)
         {	
           if (isPaused)
     		 ((Floy)objects.get(i)).resume(); 												//ak je zastavene spust 
     	   else
     		 ((Floy)objects.get(i)).suspend(); 												//ak spustene zastav
 	 	 }	  
     } 
     	
  public void updateSpeed(int speed)														//metoda na nastavenie rychlost vsetkych jedincov	
    {
	  for(int i = 0; i < objects.size(); i++)
        {	
          ((Floy)objects.get(i)).setSpeed(speed); 
     	}	    	    
    }
    
    
   public synchronized void setFloysCount(int count, int speed)											//metoda na nastavenie poctu jedincov
     {
        Floy newObject;
//        FApplet aplet;	
   	
   	    if (count >= floys_count)																//ak pridat jedincov, vytvor novych
   	      {
   	        for (;count!=floys_count; floys_count++)
   	          {	
    		    newObject = new Floy((int)(5+Math.random()*(canvas_width-10)) ,(int)(5+Math.random()*(canvas_height-10)) , maxEnergy/2, speed, Color.black,0);		//vytvorenie noveho jedinca
                objects.add(newObject);
                newObject.start();
   	  	      }
   	      }	
   	    else																					//ak ubrat jedincov, zrus poslednych v poli floyov
   	      {
   	        for (;count!=floys_count; floys_count--)
   	          {
   	         	try
   	         	  {
   	       			int i=0;
   	       			Floy pom;
   	       			pom = (Floy)objects.get(i);   
   	       				       			
   	       			while (pom.GetType() != 0)												//kym nenatrafi na domaceho floya
   	       			  {
  	       			   if(++i >= objects.size()) { System.out.println("Problem Cerv." ); floys_count--;return ; }																	//vybera jedinca z pola  	
   	       			   pom = (Floy)objects.get(i);
   	       			  }	
   	                ((Floy)objects.remove(i)).stop();
   	              }
   	            catch(SecurityException e)
   	              { }
   	          }
   	      }
 	    this.aplet.sldPocet.setValue(count);
   	 }   
   public synchronized void setFloysVotCount(int count, int speed)											//metoda na nastavenie poctu jedincov
   {
      Floy newObject;
  //    FApplet aplet;	
 	
 	    if (count >= floys_vot_count)																//ak pridat jedincov, vytvor novych
 	      {
 	        for (;count!=floys_vot_count; floys_vot_count++)
 	          {	
  		      newObject = new Floy((int)(5+Math.random()*(canvas_width-10)) ,(int)(5+Math.random()*(canvas_height-10)) , maxEnergy/2, speed, Color.black,1);		//vytvorenie noveho jedinca
              objects.add(newObject);
              newObject.start();
 	  	      }
 	      }	
 	    else																					//ak ubrat jedincov, zrus poslednych v poli floyov
 	      {
 	        for (;count!=floys_vot_count; floys_vot_count--)
 	          {
 	         	try
 	         	  {
 	       			int i=0;
 	       			Floy pom;
 	       			pom = (Floy)objects.get(i);   
 	       				       			
 	       			while (pom.GetType() != 1)												//kym nenatrafi na domaceho floya
 	       			  {
 	       			   if(++i >= objects.size()) { System.out.println("Problem mod." );  return; }																	//vybera jedinca z pola  	
 	       			   pom = (Floy)objects.get(i);
 	       			  }	
 	                ((Floy)objects.remove(i)).stop();
 	              }
 	            catch(SecurityException e)
 	              { }
 	          }
 	      }
 	    this.aplet.sldPocetVot.setValue(count);
 	 }   	
	public void SetNeighborDistance(int dist)
	  {
	  	this.neighbor_dist = dist;
	  }
	  
	public void SetCrashDistance(int dist)
	  {
		this.crash_dist = dist;
	  } 
	  
	public void SetMaxSpeed(int speed)
	  {
	  	Floy.maxspeed = speed;
	  }
	    
	public void SetAcceleration(float acc)
	  {
	  	Floy.acc = acc;
	  }
	    
	public void SetInitialSpeed(int speed)
	  {
	  	Floy.v0 = speed;
	  }	    

	public void SetBounceSpeed(float speed)
	  {
	  	Floy.bouncespeed = speed;
	  }
	  
	public void SetMaxAlienCount(int count)
	  {
	   max_pocet_votrelcov = count;	
	  }  
	    
	public int GetMaxSpeed()
	  {
	  	return ((int)Floy.maxspeed);
	  }  
	  
	public int GetNeighborDistance()
	  {
	  	return neighbor_dist;
	  }
	  
	public int GetCrashDistance()
	  {
		return crash_dist;
	  } 
	
	public float GetAcceleration()
	  {
	  	return((float)Floy.acc);
	  }  
	
	public int GetInitialSpeed()
	  {
	  	return((int)Floy.v0);
	  }
	
	public float GetBounceSpeed()
	  {
	  	return ((float)Floy.bouncespeed);
	  }  
	
	public int GetMaxAlienCount()
	  {
	  	return (max_pocet_votrelcov);
	  } 
	  
	public synchronized void OdstranMrtvehoFloya(int i)				//odtranuje mrtvych jedincov
	  {
		if(i<0 || i>objects.size()) return;
		if(((Floy)(objects.get(i))).getType() == 0)
			{
				floys_count--;
			} else
			{
				floys_vot_count--;
			}
 	    aplet.lbPocetVot.setText("Poet ervench: "+floys_count);   	     	  	
 	    aplet.lbPocetVot.setText("Poet modrch: "+floys_vot_count);   	     	  	
        aplet.sldPocet.setValue(floys_count);
        aplet.sldPocetVot.setValue(floys_vot_count);
		try
   	     {
          ((Floy)objects.remove(i)).stop();							//odstraneni mrtveho votrelca z pola
         }
   	    catch(SecurityException f)
   	    { }
   	    
   	   } 
	
	public synchronized void PridajNovehoFloya(int i)				//odtranuje mrtvych jedincov
	  {
		int speed=3;
		if(i<0 || i>=objects.size()) {System.out.println("Nesedi index"); return; }
		try
 	     {
			if(((Floy)(objects.get(i))).getType() == 0)
			{
				if(floys_count<50) 
				{ 
					floys_count++;
				} else return;
			} 
			else
			{
				if(floys_vot_count<50) 
				{
					floys_vot_count++; 
				} else return;
			}

			((Floy)(objects.get(i))).energy=maxEnergy/2;
		    Floy newObject = new Floy((int)((Floy)(objects.get(i))).GetX() ,(int)((Floy)(objects.get(i))).GetY() , maxEnergy/2, ((Floy)(objects.get(i))).getSpeed(), Color.black,(int)((Floy)(objects.get(i))).getType());		//vytvorenie noveho jedinca
            objects.add(newObject);
            newObject.start();					
         }
 	    catch(SecurityException f)
 	    { return; }
 	      aplet.lbPocetVot.setText("Poet ervench: "+floys_count);   	     	  	
 		  aplet.lbPocetVot.setText("Poet modrch: "+floys_vot_count);   	     	  	
 	      aplet.sldPocet.setValue(floys_count);
 	      aplet.sldPocetVot.setValue(floys_vot_count);
 	    
 	   }  	  	
   public void SetCursorPosition(double x, double y)
     {
      	cursor.SetX(x);
      	cursor.SetY(y);
     }
     
} 